﻿Type=Service
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: false
	#ExcludeFromLibrary: True
#End Region

#Region --- Service parts ---
Sub Process_Globals
	
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 
	' Data from your Firebase console:
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 
	'	--> Navigate to  https://console.firebase.google.com/project  
	'			- In the "Overview"  make sure there is a tile for your app 
	'			- On the upper left corner click on the gear and select "Project settings"
	'			- On the "GENERAL" tab you find the Project ID		 --> strFirebaseProjectId 
	'	
	Dim strFirebaseProjectId As String = "myid-abc1111"  ' without "https://" at the beginning and without ".firebaseio.com" and without "/" at the end
	' 		- correct --> "mytestapp-4c1f8"
	'		- wrong   --> "https://mytestapp-4c1f8"
	'		- wrong   --> "https://mytestapp-4c1f8/"
	' ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ ~~ 

	Dim auth As FirebaseAuth			
	Dim mapCurrentUser As Map

	Dim strFirebaseSignedInUserToken As String = ""
	
	Dim realtime As FirebaseDatabase 	

	'Public storage As FilrebaseStorage
	Public bucket As String = $"gs://${strFirebaseProjectId}.appspot.com"$ ' from Firebase console ("Storage")
		
	Dim tmrFiBaAuthTokenRefresh As Timer

	Dim fbdb As fibadbhelp

'	Public kvs As KeyValueStore	
'	Dim strFirebaseProjectRefUrl As String = $"https://${strFirebaseProjectId}.firebaseio.com"$

End Sub

Sub Service_Create
	' -- -- -- -- -- -- -- -- -- -- -- -- -- 
	' Firebase 
	' -- -- -- -- -- -- -- -- -- -- -- -- -- 
	auth.Initialize("auth")
	tmrFiBaAuthTokenRefresh.Initialize("tmrFiBaAuthTokenRefresh", 58 *DateTime.TicksPerMinute)  ' Avoid unvalid tokens
	tmrFiBaAuthTokenRefresh.Enabled = True

	'storage.Initialize("storage", bucket) ' we use this later to handle pictures or other files 
	
	' ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 
	' Does anyone know how to set the debug level?
		''realtime.LogLevel = ???? '"DEBUG" ' "INFO", "NONE" 
	' ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? 		
		
End Sub

Sub Service_Start (StartingIntent As Intent)
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	tmrFiBaAuthTokenRefresh.Enabled = False
End Sub

#End Region

#Region --- Firebase Auth Tokens ---
Sub tmrFiBaAuthTokenRefresh_Tick
	Log("#-tmrFiBaAuthTokenRefresh_Tick")
	If strFirebaseSignedInUserToken.Length > 0 Then 
		CallSubDelayed(Me, "authTokenRefresh")
	End If
End Sub
Sub authTokenRefresh
	Log("#-starter.authTokenRefresh")	
	auth.GetUserTokenId(auth.CurrentUser, True)	
End Sub

Sub auth_TokenAvailable (User As FirebaseUser, Success As Boolean, TokenId As String)
	Log("#-starter.auth_TokenAvailable, Success=" & Success ) '& ", TokenId=" & TokenId)
	If Success Then 
		strFirebaseSignedInUserToken = TokenId
	Else
		strFirebaseSignedInUserToken = ""
	End If
End Sub
#End Region


