﻿Type=Activity
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
	' --- --- --- --- 
	' USE ALWAYS @DonManfreds MOST RECENT Wrap of the Firebase-Realtime-Database-Library --> https://www.b4x.com/android/forum/threads/firebase-realtimedatabase.69773/
	' 																		     or here --> https://www.b4x.com/android/forum/threads/firebase-realtimedatabase.69773/page-2#post-455528
	' --- --- --- --- 
'   ║
'   ║  		a) Realtime  --> EVENT DRIVEN access to data 
'   ║
'   ║                        In the "Files"-folder is a file with testdata that you MAY IMPORT in the Firebase console:  "fir-quickstartsforandroid-testdata.json"
'   ║
'   ║                        *** BE AWARE THAT AN IMPORT WILL DELETE ALL OTHER EXISTING DATA 
'   ║                            IN THE FIREBASE DATABASE NODE THAT IS SELECTED ***
'
'    Good to read NoSQL infos:
'		a) https://highlyscalable.wordpress.com/2012/03/01/nosql-data-modeling-techniques/
'		b) https://www.airpair.com/firebase/posts/firebase-building-realtime-app
'		c) https://www.airpair.com/firebase/posts/structuring-your-firebase-data
'

#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

#Region --- Activity parts ---

Sub Process_Globals
	'Private nativeMe As JavaObject	
End Sub

Sub Globals
	Dim ref As DatabaseReference
	Dim tempuserref As DatabaseReference 
	'
	Private btnInitNew As Button
	Private btnSend As Button
	Private edtBody As EditText
	Private edtPath As EditText
	Private edtTitle As EditText
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label5 As Label
	Private Label6 As Label
	Private lblInfo As Label
	Private lblSnapshot As Label
	Private lblUser As Label
	Private lblUserId As Label
	Private Panel1 As Panel
	Private Panel2 As Panel
	Private Panel3 As Panel
	Private Panel4 As Panel
	Private Panel7 As Panel
	Private edtPathSet As EditText
	Private edtValSet As EditText
	Private btnSet As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Log("#- ═══════")
	
	Dim sv As ScrollView : sv.Initialize(200%y)
	sv.Panel.LoadLayout("testfibart")
	sv.Panel.Color = Colors.White
	
	Activity.AddView(sv, 0, 0, 100%x, 100%y)

	Panel1.Width = 100%x -Panel1.Left *2
	Panel2.Width = 100%x -Panel2.Left *2
	Panel3.Width = 100%x -Panel3.Left *2
	Panel4.Width = 100%x -Panel4.Left *2
	Panel7.Width = 100%x -Panel7.Left *2

	lblUser.Width   = Panel7.Width -lblUser.Left -16dip
	lblUserId.Width = Panel7.Width -lblUserId.Left -16dip

	edtPath.Width = Panel3.Width -edtPath.Left -16dip
	
	lblSnapshot.Width = Panel4.Width -lblSnapshot.Left *2

	edtPathSet.Width = Panel2.Width -edtPathSet.Left -16dip
	edtValSet.Width  = Panel2.Width -edtValSet.Left -16dip
	btnSet.Left = Panel2.Width -btnSet.Width -16dip

	edtTitle.Width = Panel1.Width -edtTitle.Left -16dip
	edtBody.Width  = Panel1.Width -edtBody.Left -16dip
	btnSend.Left = Panel1.Width -btnSend.Width -16dip
	
	btnInitNew.Left = edtPath.Left +edtPath.Width -btnInitNew.Width

	If FirstTime Then 
		PrepRealtimeDb
	End If

End Sub

Sub Activity_Resume
	If Starter.strFirebaseProjectId.Contains(" ") Or Starter.strFirebaseProjectId.Contains(" ") Then 
		Msgbox("*** You have to set up your Firebase parameters in the Starter-module", "Not ready for testing!")
		Return
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Initialize
	Log(" ")
	Log("#-testfibart.Initialize")	
	showFiBaUser	
	
	edtTitle.Hint = "Post title"
	edtBody.Hint  = "Your message"
	edtTitle.Text = "🔥 Testtitle with NOW -> " & DateTime.Now
	edtBody.Text  = "Testmessage with now -> " & DateTime.Now
	edtPath.Text = "testnode1" ' <-- This is the top node for your experiments. The userlist and posts etc. are under this

	PrepRefOnTopnode(edtPath.Text)

End Sub

Sub btnInitNew_Click
	Log(" ")
	Log("#-btnInitNew_Click")	
	lblSnapshot.Text = "(running)"
	PrepRefOnTopnode(edtPath.Text)
End Sub

Sub showFiBaUser
	Log("#-testfibart.showFiBaUser")
	For Each k In Starter.mapCurrentUser.Keys
		Log($"#-  ${k} = ${Starter.mapCurrentUser.Get(k)}"$)
	Next
	'
	If Starter.mapCurrentUser.GetDefault("Uid", "-1") = "-1" Then 
		lblUser.Text   = "(empty)"
		lblUserId.Text = "(empty)"
		'		ImageView1.Bitmap = Null		
	Else
		lblUser.Text   = Starter.mapCurrentUser.GetDefault("DisplayName", "")
		lblUserId.Text = Starter.mapCurrentUser.GetDefault("Uid", "")
		'  
		'		Dim links As Map
		'		links.Initialize
		'		links.Put(ImageView1, Starter.mapCurrentUser.GetDefault("PhotoUrl", ""))
		'		CallSubDelayed2(ImageDownloader, "Download", links)
	End If
	'	
End Sub


'' Just a few little helpers
'Sub raJsonToMap(strJSON As String) As Map
'    Dim jMap As Map         : jMap.Initialize
'    Dim JSON As JSONParser    : JSON.Initialize(strJSON)
'    jMap = JSON.NextObject
'    Return jMap
'End Sub
'Sub raMapToJson(mapX As Map) As String
'	Dim jsonGen As JSONGenerator
'	jsonGen.Initialize(mapX)
'	Return jsonGen.ToString
'End Sub
'Sub raJsonPretty(strJson As String) As String
'	Dim j As JSONGenerator
'	j.Initialize(raJsonToMap(strJson))
'	Return j.ToPrettyString(4)
'End Sub
#End Region
' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 

#Region -- Firebase REALTIME Database --
Sub PrepRealtimeDb
	Log(" ")
	Log("#-PrepRealtimeDb")	
  	Starter.realtime.Initialize("Realtime")
	Starter.realtime.PersistenceEnabled = True
    Starter.realtime.goOnline
	
	Starter.realtime.purgeOutstandingWrites '???
	
End Sub
'
Sub PrepRefOnTopnode(strNewTopNode As String)
	Log(" ")
	Log("#-PrepRefOnTopnode, strNewTopNode=" & strNewTopNode)
	
	' First make us a reference to the TopLevelNode
    ref.Initialize("Reference", Starter.realtime.getReferencefromUrl($"https://${Starter.strFirebaseProjectId}.firebaseio.com/${strNewTopNode}/"$) )
    ref.addChildEventListener
    ref.addListenerForSingleValueEvent
    ref.addValueEventListener	
	
	' Now we want make sure the user is in the list "users" of the TopLevelNode
	CallSubDelayed2(Me, "PrepUserEntry", ref)

End Sub
'

' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 
' POST
' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 
Sub btnSend_Click
	Log(" ")
	Log("#-btnSend_Click")
	submitPost(edtTitle.Text, edtBody.Text)
End Sub
 
Sub submitPost(strTitle As String, strBody As String)
	Log("#-submitPost, strTitle=" & strTitle & ", strBody=" & strBody)
	If strTitle.Length < 1 Then
		edtTitle.Hint = "Enter a title"
		edtTitle.HintColor = Colors.Red
		Return
	Else
		edtTitle.HintColor = Colors.Gray
	End If
	
	If strBody.Length < 1 Then
		edtBody.Hint = "Enter a message"
		edtBody.HintColor = Colors.Red
		Return
	Else
		edtBody.HintColor = Colors.Gray
	End If
	
	Dim bolWpOk As Boolean = writeNewPost(Starter.mapCurrentUser.GetDefault("Uid", "") , Starter.mapCurrentUser.GetDefault("DisplayName", ""), strTitle, strBody)
	Log("#-  bolWpOk=" & bolWpOk)
	
End Sub

Sub writeNewPost(strUid As String, strUNam As String, strTitle As String, strBody As String) As Boolean 
	Log("#-writeNewPost, strUid=" & strUid & ", strUNam=" & strUNam & ", strTitle=" & strTitle & ", strBody=" & strBody)	
	'  
   	Dim tempref As DatabaseReference = ref.Child("posts") ' <-- One node we want to write the data to
    Dim posts As DatabaseReference = tempref.push         ' <-- We just needed this reference to get the autogenerated KEY
    Dim key As String = posts.Key 
    Log("#-  key=" & key) 

    Dim mapPostValues As Map
    mapPostValues.Initialize
    mapPostValues.Put("Uid", strUid)
    mapPostValues.Put("UNam", strUNam)
    mapPostValues.Put("tstamp", DateTime.Now)
    mapPostValues.Put("tstamp2", DateTime.Date(DateTime.Now) & ", " & DateTime.Time(DateTime.Now))
    mapPostValues.Put("Title", strTitle)
    mapPostValues.Put("Body", strBody)

    ' "Fanout" the data to different paths (NoSQL recommendation for up to 1 million simultaneous users)  --> https://firebase.googleblog.com/2015/10/client-side-fan-out-for-data-consistency_73.html
    Dim strUk1 As String = "/posts/" & key
    Dim strUk2 As String = "/user-posts/" & strUid & "/" & key
    Log("#-  strUk1=" & strUk1) 
    Log("#-  strUk2=" & strUk2) 
 
    Dim childUpdates As Map
    childUpdates.Initialize
    childUpdates.Put(strUk1, mapPostValues)
    childUpdates.Put(strUk2, mapPostValues)
    ref.updateChildren(childUpdates)      ' <-- This is the "atomic" update. ONE start of transaction no matter how many elements the map has
    'Log("#-  childUpdates=" & childUpdates)	
	
	Return True
	
End Sub

' »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  
' SET
' »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  
Sub btnSet_Click
	Log(" ")
	Log("#-btnSet_Click")
	' ...
	
End Sub

Sub Reference_onCancelled(errnum As Int,error As String)
    Log($"Reference_onCancelled(${errnum},${error})"$)
End Sub
Sub Reference_onChildAdded(snapshot As Object, child As String)
    Log($"Reference_onChildAdded(${child})"$)
    Dim snap As DataSnapshot = snapshot
	lblSnapshot.Text =  snap.Value
End Sub
Sub Reference_onChildChanged(snapshot As Object, child As String)
    Log($"Reference_onChildChanged(${child})"$) 
    Dim snap As DataSnapshot = snapshot
	lblSnapshot.Text =  snap.Value
End Sub
Sub Reference_onChildMoved(snapshot As Object, child As String)
    Log($"Reference_onChildMoved(${child})"$) 
    Dim snap As DataSnapshot = snapshot
	lblSnapshot.Text =  snap.Value
End Sub
Sub Reference_onChildRemoved(snapshot As Object)
    Log($"Reference_onChildRemoved()"$)
    Dim snap As DataSnapshot = snapshot
	lblSnapshot.Text =  snap.Value
End Sub
Sub Reference_onDataChange(snapshot As Object)
    Log($"Reference_onDataChange()"$)
    Try
        Dim snap As DataSnapshot = snapshot
		lblSnapshot.Text =  snap.Value

        Dim x As String = snap.Value
        If x.Length > 0 Then  
            x = x.SubString2(0, Min(32, x.Length -1)) & "..."
        End If
        Log("#-  Value=" & x)
    Catch
        Log("#-  ERROR..." & CRLF & LastException.Message)
     
    End Try
End Sub

Sub Reference_onComplete(errorCode As Int, errorMessage As String, errObj As Object, dbref As Object)
    Log($"Reference_onComplete(${errorCode},${errorMessage})"$)
    If errObj <> Null Then
        Dim err As DatabaseError = errObj
        Log($"  err.Code   =${err.Code}"$)
        Log($"  err.Details=${err.Details}"$)
        Log($"  err.Message=${err.Message}"$)
    End If
    If dbref <> Null Then
        Dim ref As DatabaseReference = dbref
        Log($"  ref.Key=${ref.Key}"$)
    End If
End Sub

Sub lblSnapshot_Click
	Msgbox(lblSnapshot.Text, "Content of Snapshot")
End Sub



Sub PrepUserEntry(refOfTopNode As DatabaseReference)
	Log("#-PrepUserEntry")
	
	'  Make sure the UserId is in the "users" list
	Dim strUidPath As String = "users/" & Starter.mapCurrentUser.GetDefault("Uid", "-1")  ' <--Point A
	Log("#-  strUidPath=" & strUidPath)
	tempuserref.Initialize("tempuserref" , refOfTopNode.Child(strUidPath) ) ' e.g. <-- https://yyymyprojectid123.firebaseio.com/testnode1/users/-KTclQUDpdelku0RSZ5fq
	tempuserref.Value = Starter.mapCurrentUser ' <-- We just set the map with the userinfo as "the value" and it will be added or updated to the path above (Point A) automatically by Firebase
End Sub


'╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗╗
'	lib:Raising.. tempuserref_oncomplete()
'	~e:java.lang.Exception: Sub tempuserref_oncomplete signature does not match expected signature.
'   -->why??

'Sub tempuserref_onComplete(errorCode As Int, errorMessage As String, errObj As Object, dbRef As Object)
'    Log($"tempuserref_onComplete(${errorCode},${errorMessage})"$)
'    If errObj <> Null Then
'        Dim err As DatabaseError = errObj
'        Log($"  err.Code   =${err.Code}"$)
'        Log($"  err.Details=${err.Details}"$)
'        Log($"  err.Message=${err.Message}"$)
'    End If
'    If dbRef <> Null Then
'        Dim tempuserref As DatabaseReference = dbRef
'        Log($"  ref.Key=${tempuserref.Key}"$)
'    End If
'End Sub


#End Region